/* =============================================================[ Display.hh ]=
 * Display.hh - print information on a display
 * Copyright (C) 2002 Hubert Chan <hubert@uhoreg.ca>
 *
 * ----------------------------------------------------------------( License )-
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * ------------------------------------------------------------( Description )-
 *
 * This file handles displaying player information to a display.
 *
 * ------------------------------------------------------------------------- */

#ifndef __DISPLAY_HH_
#define __DISPLAY_HH_

#include <string>

#include "SessionData.hh"

class Display : public ModeSubscriber
{
protected:
  unsigned int width, height;
  Display(SessionData& data)
    : ModeSubscriber(data), width(0), height(0) {}
  Display(SessionData& data, unsigned int w, unsigned int h)
    : ModeSubscriber(data), width(w), height(h) {}
public:
  static Display *create(SessionData &);
  virtual ~Display() {}

  virtual void print(playermode_t, unsigned int line, const std::string &) = 0;
  unsigned int getWidth() const { return width; };
  unsigned int getHeight() const { return height; };
};

#endif //__DISPLAY_HH_
